﻿Public Class Form1

    Private rpt As New Rpt()
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        'Remove the default printer button
        Me.viewer1.Toolbar.Tools.RemoveAt(2)
        ' Create and add the custom button
        Dim btn As New DataDynamics.ActiveReports.Toolbar.Button()
        btn.Caption = "MyPrint"
        btn.ToolTip = "Custom Print Button"
        btn.ImageIndex = 1
        btn.ButtonStyle = DataDynamics.ActiveReports.Toolbar.ButtonStyle.TextAndIcon
        btn.Id = 333
        Me.viewer1.Toolbar.Tools.Insert(2, btn)
        Viewer1.Document = rpt.Document
        rpt.Run()
    End Sub

    Private Sub Viewer1_ToolClick_1(sender As System.Object, e As DataDynamics.ActiveReports.Toolbar.ToolClickEventArgs) Handles Viewer1.ToolClick
        ' Capture the new tool's click to show the dialog
        If e.Tool.Id = 333 Then
            arScale()
        End If
    End Sub


    Private aPage As DataDynamics.ActiveReports.Document.Page
    Private Sub arScale()
        aPage = New DataDynamics.ActiveReports.Document.Page()
        Dim m_myARPrinter As New DataDynamics.ActiveReports.Interop.SystemPrinter()
        m_myARPrinter.StartJob("Your Printer Name Goes Here")

        Dim rcPage As System.Drawing.RectangleF = New RectangleF()

        Dim nCount As Integer = rpt.Document.Pages.Count

        For i As Integer = 0 To nCount - 1
            m_myARPrinter.StartPage()
            aPage = rpt.Document.Pages(i)
            If i = 0 Then
                'If this is the first page, we want a different page size and paper source
                m_myARPrinter.PaperSource = m_myARPrinter.PrinterSettings.PaperSources(3)
                m_myARPrinter.PaperSize = m_myARPrinter.PaperSizes(0)
                m_myARPrinter.Graphics.PageUnit = System.Drawing.GraphicsUnit.Pixel
                rcPage.Width = aPage.Width
                rcPage.Height = aPage.Height
            Else
                m_myARPrinter.PaperSource = m_myARPrinter.PrinterSettings.PaperSources(0)
                m_myARPrinter.PaperSize = m_myARPrinter.PaperSizes(2)
                m_myARPrinter.Graphics.PageUnit = System.Drawing.GraphicsUnit.Pixel
                rcPage.Width = aPage.Width
                rcPage.Height = aPage.Height
            End If

            aPage.Draw(m_myARPrinter.Graphics, rcPage)
            m_myARPrinter.EndPage()
        Next

        m_myARPrinter.EndJob()
    End Sub


End Class
